// Simul.h


#pragma once


#include "Conf.h"



const int delayCarChangeDir = 10;

const int probaBrakeNormal  =  5; // %
const int probaBrakeSnail   = 50; // %

const int maxSpeedNormal = 100;
const int maxSpeedSnail  = 1;

class CGraphView;



struct MOVE
{
	int dir;
	int probaCumul;
};
const int maxMove = 3;


class CLight
{
public:  // Functions
	
	void Tick();
	
	
public:  // Data
	
	CPoint m_ptDraw;    // Drawing position
	int    m_dirDraw;   // Offset direction for drawing
	
	bool   m_fGreen;
	int    m_delayChange;
	
	int    m_timeG;
	int    m_timeR;
};


const int maxCarSpeed = 4;
const int maxFrom     = 8;

struct MOVE_DIR
{
	int  nbMove;
	MOVE aMove[maxMove];
};

struct MOVING
{
	bool     fHasMoved;    // TRUE if a car has moved from here
	int      nbFrom;
	int      aFrom[maxFrom];
	POSITION posEmpty;     // Position in lstEmpty if the unit has no car
};


class CNode;

struct GENERATOR
{
	const CNode *pNode;
	CPoint pt;
	int    probaNewCar;
	int    dir;           // Used as initial direction for generated cars
	
	int    nbCreated;
	int    nbDestroyed;
};


struct UNIT
{
	CPoint     pt;
	bool       fValid;
	int        maxSpeed;      // Speed limit
	CLight    *pLight;        // Green/red lights
	MOVE_DIR   aMoveDir[8];   // Possible moves
	MOVING     mov;
	
	GENERATOR *pGen;
};


struct CAR
{
	int    id;               // = 0 -> no car
	int    timeCreated;      // Creation time
	GENERATOR *pGen;         // Car generator
	int    iSpeed;
	int    maxSpeed;
	int    probaBrake;
	int    dir;              // Moving direction
	int    dirTo;            // Wanted direction, -1 if none has been decided
	
	CPoint pt;
	bool   fCanMove;         // Time specific (often updated)
	int    nbMove;           // Number of moves done in a time iteration
	                         // (can be > 1 if maxCarSpeed > 1)
	int    delayChangeDir;   // Number of iterations after which the car
	                         // will change its direction (dirTo)
	
	void SetDir(CPoint ptFrom);
	void OnUpdateSpeed(CGraphView* pView);
};
